<template>
  <input type="text" :id="_uid">
</template>

<script>
export default {
  props: {
    validate: {
      type: Function,
      required: false,
      default: null,
    },
    alwaysreset: {
      type: Boolean,
      default: false,
    },
  },
  mounted() {
    let el = document.getElementById(this._uid);

    el.addEventListener('focusin', () => {
      if (this.$props.alwaysreset)
        el.value = null;
      else
        el.setSelectionRange(el.value.length, el.value.length);
    });

    el.addEventListener('focusout', async () => {
      if (this.$props.validate) {
        if (await this.$props.validate(el.value))
          el.classList.remove('error');
        else
          return el.classList.add('error');
      }
      this.$emit('finished', el.value);
    });
  },
};
</script>

<style scoped>
input {
  background: transparent;
  border: none;
  border: 1px solid transparent;
  opacity: .6;

  cursor: pointer;
  transition: .25s all;
}

input:focus {
  opacity: 1;

  cursor: text;
}

input.error {
  color: red;
}
</style>
